#include "treeitem.h"

TreeItem::TreeItem()
{
    children = QList<TreeItem*>();
}

TreeItem::~TreeItem(){
    while(children.length() > 0){
        TreeItem* t = children[0];
        children.removeAt(0);
        t->~TreeItem();
    }
}

void TreeItem::setParent(TreeItem *parent){
    this->parent = parent;
}

TreeItem* TreeItem::getParent(){
    return parent;
}

int TreeItem::getChildrenCount(){
    return children.length();
}

//adds to child list AND sets itself as parent.
void TreeItem::addChild(TreeItem *item){
    children.append(item);
    item->setParent(this);
}

//removes from children list. Does NOT delet child.
bool TreeItem::removeChild(TreeItem *item){
    return children.removeOne(item);
}

QList<TreeItem*> TreeItem::getChildren(){
    return children;
}

TreeItem* TreeItem::getChild(int index){
    if (index < children.length()){
        return children[index];
    }
    return 0;
}
